/*
 * Terminal Interface
 *
 * Copyright (C) 2006-2016 Magnus Bergman <magnus.bergman@snisurset.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef terminal_interface_h
#define terminal_interface_h

typedef struct _Terminal Terminal;

typedef struct{
    void(*gotoxy)(Terminal*,int x,int y);
    void(*up)(Terminal*,int);
    void(*down)(Terminal*,int);
    void(*left)(Terminal*,int);
    void(*right)(Terminal*,int);

    void(*foreground)(Terminal*,int);
    void(*background)(Terminal*,int);
    void(*set_attribute)(Terminal*,int);

    void(*write)(Terminal*,int);
    void(*clrscr)(Terminal*);
    void(*clreol)(Terminal*);

    int(*get_foreground)(Terminal*);
    int(*get_background)(Terminal*);
    int(*get_cursorx)(Terminal*);
    int(*get_cursory)(Terminal*);
}TerminalInterface;

#endif /* terminal_interface_h */
