#ifndef doc_frame_tag_h
#define doc_frame_tag_h

#include "anidir.h"
#include "color.h"

namespace doc{
    class FrameTag{
    private:
        int _from;
        int _to;
        color_t _color;
        AniDir _ani_dir;
    public:
        FrameTag(int from, int to):_from(from),_to(to){};
        FrameTag(const FrameTag&);

        int fromFrame() const { return _from; }
        int toFrame() const { return _to; }
        const std::string &name() const { return NULL; }
        color_t color() const { return _color; }
        AniDir aniDir() const { return _ani_dir; }

        void setName(const std::string &name) const {}
        void setColor(color_t c) { _color = c; };
        void setAniDir(AniDir ad) { _ani_dir = ad; };
    };
}

#endif /* doc_frame_tag_h */
