#ifndef doc_image_bits_h
#define doc_image_bits_h

#include "gfx/clip.h"
#include "gfx/rect.h"

namespace doc{
    template<typename ImageTraits> class ImageIterator;

    template<typename ImageTraits>
    class ImageBits{
    private:
        Image *_image;
        gfx::Rect _bounds;
    public:
        typedef ImageIterator<ImageTraits> iterator;
        ImageBits(Image *img, const gfx::Rect &b):
            _image(img),
            _bounds(b)
        {}

        iterator begin() { return iterator(_image,_bounds,_bounds.x,_bounds.y); }
        iterator end() {
            iterator it(_image,_bounds,_bounds.x+_bounds.w-1,_bounds.y+_bounds.h-1);
            ++it;
            return it;
        }
    };

    template<typename ImageTraits>
    class LockImageBits{
    private:
        typedef ImageBits<ImageTraits> Bits;
        Bits _bits;
    public:
        typedef typename Bits::iterator iterator;
        LockImageBits(Image *img, const gfx::Rect &b):
            _bits(img,b)
        {}

        iterator begin() { return _bits.begin(); }
        iterator end() { return _bits.end(); }
    };

}

#endif /* doc_image_bits_h */
