/*
 * Copyright (C) 2020  Magnus Bergman <magnus@snisurset.net>
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, see <http:/www.gnu.org/licenses/>
 */
#include <abydos-plugin.h>
#include <debug.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>

/*

___________________ _________ _________ _________
0x54 0x43 0x53 0x46 0x02 0x29 0x00 0x01 0x03 0x00

0x20	0x10	0x00	0x00	0x00	0x00    0x00	0x00	0x15	0xa4
0x20	0x10	0x00	0x00    0x00	0x00	0x00	0x00	0x16	0x88
0x20	0x10    0x00	0x00	0x00	0x00	0x00	0x00	0x17	0x92
0x20	0x10	0x00	0x00	0x00	0x00	0x00	0x00    0x18	0x76
0x20	0x10	0x00	0x00	0x00	0x00    0x00	0x00	0x19	0x4c
0x20	0x10	0x00	0x00    0x00	0x00	0x00	0x00	0x1a	0x2a
0x20	0x10    0x00	0x00	0x00	0x00	0x00	0x00	0x1c	0x0c
0x20	0x10	0x00	0x00	0x00	0x00	0x00	0x00    0x1c	0xd2
0x20	0x10	0x00	0x00	0x00	0x00    0x00	0x00	0x1f	0xb2
0x20	0x10	0x00	0x00    0x00	0x00	0x00	0x00	0x20	0x7c
0x20	0x10    0x00	0x00	0x00	0x00	0x00	0x00	0x21	0x94
0x20	0x10	0x00	0x00	0x00	0x00	0x00	0x00

228

_________           0________           __Z______ __C_n+1__
0x00 0x11 0x24 0x06 0x00 0x00 0xbd 0xd7 0x00 0x12 0x00 0x03 0xbc 0x40 0xbd 0x40
                    !________ __C_n+1__           __Z______ __C_n+1__
0xbd 0x40 0xad 0xc0 0x05 0xe6 0x00 0x00 0xbd 0xd7 0x00 0x10 0x00 0x03 0xe5 0xb2
                              !________ __C_n+1__           __Z______ __C_n+1__
0xe5 0xb2 0xe5 0xb2 0xbd 0x40 0x05 0xe8 0x00 0x00 0xbd 0xd7 0x00 0x0c 0x00 0x06
                                                                      !________
0x98 0x00 0xd0 0x00 0xd0 0x00 0xd0 0x00 0xd0 0x00 0xd0 0x00 0xf8 0x00 0x05 0xe6
__C_n+1__           __Z______ __C_n+1__
0x00 0x00 0xbd 0xd7 0x00 0x06 0x00 0x09 0x98 0x00 0x98 0x00 0x80 0x00 0x98 0x00
                                                            !_______  __C_X+1__
0x98 0x00 0xd0 0x00 0xd0 0x00 0x98 0x00 0xd0 0x00 0xf8 0x00 0x05 0xe6 0x00 0x0c

0xbd 0xd7 0x60 0x00 0x98 0x00 0x98 0x00 0x60 0x00 0x80 0x00 0x98 0x00 0x98 0x00
                                                  !________ __C n+1__
0x98 0x00 0x98 0x00 0xd0 0x00 0x98 0x00 0xf8 0x00 0x05 0xe8 0x00 0x01 0xe5 0xb2
          __Z______ __C_n+1__
0xe5 0xb2 0x00 0x02 0x00 0x08 0x60 0x00 0x72 0xc4 0x9b 0x88 0xfe 0xa0 0x9b 0x88
                                        !_______  __C_n+1__
0x9b 0x88 0x9b 0x88 0xe5 0xb2 0xe5 0xb2 0x05 0xf0 0x00 0x06 0x98 0x00 0x98 0x00
                                                  !________ __C_n+1__
0x98 0x00 0xd0 0x00 0xd0 0x00 0xd0 0x00 0xd0 0x00 0x05 0xf2 0x00 0x02 0xa3 0xc9
                    __Z______ __C_n+1__                               !________
0x72 0xc4 0x72 0xc4 0x00 0x04 0x00 0x02 0x83 0x06 0x83 0x06 0xa3 0xc9 0x05 0xf0
__C_n+1__                     __Z______ __C_n+1__
0x00 0x01 0x72 0xc4 0xa3 0xc9 0x00 0x08 0x00 0x02 0x83 0x06 0xa3 0xc9 0xa3 0xc9
!________ __C_n+1__                               __Z______ __C_n+1__
0x05 0xec 0x00 0x02 0x72 0xc4 0xa3 0xc9 0x72 0xc4 0x00 0x0a 0x00 0x02 0x83 0x06

0xa3 0xc9 0xa3 0xc9

*/

typedef struct{
    int width;
    int height;
    cairo_surface_t *surface;
}page_t;

struct _abydos_plugin_handle_t{
    abydos_plugin_info_t *info;
    page_t *page;
};


static const char **
_spooky_get_mime_types()
{
    static const char *mime_types[] = {
        "image/x-spooky-sprites",
        NULL
    };
    return mime_types;
}


static abydos_plugin_handle_t *
_spooky_new(const char *mime_type, abydos_plugin_info_t *info)
{
    abydos_plugin_handle_t *h = (abydos_plugin_handle_t*)malloc(sizeof(abydos_plugin_handle_t));
    h->info = info;
    info->threadsafe = 1;
    h->page = NULL;
    return h;
}


static void
_spooky_free(abydos_plugin_handle_t *h)
{
    if(h->page){
        int i;
        for(i=0;i<h->info->page_count;++i)
            if(h->page[i].surface)
                cairo_surface_destroy(h->page[i].surface);
        free(h->page);
    }
    free(h);
}


#define get8(a) (*(uint8_t*)(a))
#define get16(a) be16toh(*(uint16_t*)(a))
#define get32(a) be32toh(*(uint32_t*)(a))


static int
_getsize(int a)
{
    return a ? a : 256;
}


static uint32_t
_decode_rgb(uint16_t c)
{
    int r = (c & 0xf800) >> 11;
    int g = (c & 0x07e0) >> 5;
    int b = (c & 0x001f);
    r = r<<3|r>>2;
    g = g<<2|g>>4;
    b = b<<3|b>>2;
    return r<<16|g<<8|b<<0|255<<24;
}


static int
_handle_unpacked(page_t *page, const uint8_t *data, const uint8_t *end)
{
    uint32_t *dst = (uint32_t*)cairo_image_surface_get_data(page->surface);
    //int stride = cairo_image_surface_get_stride(page->surface);
    int pixels = page->width * page->height;
    while(pixels-- > 0){
        int pix = get16(data);
        data += 2;
        /* black pixels are transparent */
        *dst++ = pix ? _decode_rgb(pix) : 0;
    }
    cairo_surface_mark_dirty(page->surface);
    return 0;
}


static int
_handle_packed(page_t *page, const uint8_t *data, const uint8_t *end)
{
    uint32_t *dst = (uint32_t*)cairo_image_surface_get_data(page->surface);
    //int stride = cairo_image_surface_get_stride(page->surface);
    int chunks = get16(data)+1;
    data += 2;

    DEBUG_p("chunks: %d",chunks);

    while(chunks-- > 0){
        int c = get16(data);
        data += 2;
        //DEBUG_p("# %d empty pixels (0x%04x)",c,c);
#if 1
        c = (c/2) % page->width;
        //DEBUG_p("  %d empty pixels (0x%04x)",c,c);
#else
        if(c>256){
            c = (c/2)-752;
            DEBUG_p("  %d empty pixels (0x%04x)",c,c);
        }else{
            c /= 2;
            DEBUG_p("  %d empty pixels",c);
        }
#endif
        while(c-->0)
            *dst++ = 0;
        c = get16(data)+1;
        data += 2;
        while(c-- > 0){
            *dst++ = _decode_rgb(get16(data));
            data += 2;
        }
    }

    DEBUG_p("pixel diff: %d",page->width*page->height - (int)(dst-(uint32_t*)cairo_image_surface_get_data(page->surface)));

#if 0
    int entire_size = this.Xres * height; //total pixels the image should have
    int current_size = pixels.size(); //current pixels we have
    int difference = entire_size - current_size;
    while(difference-- > 0)//we must pad if difference is > 0
        pixels.add(this.emptyPixel);
    return pixels;
#endif
    cairo_surface_mark_dirty(page->surface);
    return 0;
}


static int
_spooky_create_from_data(abydos_plugin_handle_t *h,const char *data, size_t len)
{
    int header_size;
    int entry_size;
    if(len<4)
        return -1;
    if(!memcmp((void*)data,"TCSF",4)){
        int i;
        switch(get16(data+6)){
        case 1:
        case 2:
            DEBUG_p("version 1");
            header_size = 10;
            entry_size = 10;
            break;
        case 3:
            DEBUG_p("version 3");
            header_size = 10;
            entry_size = 10;
            break;
        default:
            DEBUG_p("unhandled version");
            return -1;
        }
        h->info->page_count = get16(data+4);
        if(len<header_size + h->info->page_count*entry_size)
            return -1;
        h->page = (page_t*)calloc(h->info->page_count,sizeof(page_t));
        for(i=0;i<h->info->page_count;++i){
            off_t offs;
            h->page[i].width = _getsize(get8(data+header_size+i*entry_size+0));
            h->page[i].height = _getsize(get8(data+header_size+i*entry_size+1));
            h->page[i].surface = cairo_image_surface_create(CAIRO_FORMAT_ARGB32, h->page[i].width, h->page[i].height);
            DEBUG_p("page %d size: %dx%d",i,h->page[i].width,h->page[i].height);
            offs = get32(data+header_size+i*entry_size+2);
            DEBUG_p("unpacked offset: %d",(int)offs);
            if(offs){
                if(_handle_unpacked(&h->page[i],(uint8_t*)data+offs,(uint8_t*)data+len)<0)
                    DEBUG_p("failed to decode");
            }else{
                offs = get32(data+header_size+i*entry_size+6);
                DEBUG_p("packed offset: %d",(int)offs);
                if(_handle_packed(&h->page[i],(uint8_t*)data+offs,(uint8_t*)data+len)<0)
                    DEBUG_p("failed to decode");
            }
        }
        DEBUG_p("xres: %d",get16(data+8));
        /* 384, 768 */
        h->info->pixel_ratio = 384.0/get16(data+8);
        return 0;
    }else if(!memcmp((void*)data,"tru?",4)){
    }
    return -1;
}


static cairo_surface_t *
_spooky_get_image_surface(abydos_plugin_handle_t *h,
                       int page,
                       cairo_bool_t *layer_visibility,
                       int variant,
                       double time,
                       int frame)
{
    return cairo_surface_reference(h->page[page].surface);
}


static void
_spooky_get_page_info(abydos_plugin_handle_t *h, int page, abydos_plugin_page_info_t *info)
{
    info->width = h->page[page].width;
    info->height = h->page[page].height;
}


const abydos_plugin_interface_t *
Abydos0()
{
    static const abydos_plugin_interface_t p = {
        .version = ABYDOS_PLUGIN_INTERFACE_VERSION,
        .get_mime_types = _spooky_get_mime_types,
        .new = _spooky_new,
        .free = _spooky_free,
        .create_from_data = _spooky_create_from_data,
        .get_image_surface = _spooky_get_image_surface,
        .get_page_info = _spooky_get_page_info
    };
    return &p;
}
