/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef abydos_buffer_h
#define abydos_buffer_h

#include <stddef.h>
#include <stdint.h>

#define ABYDOS_BUFFER_SIZE 4096

typedef struct{
    uint8_t buffer[ABYDOS_BUFFER_SIZE];
    size_t buffer_len;
    size_t buffer_pos;
    const uint8_t *data;
    size_t data_len;
    size_t data_pos;
}abydos_buffer_t;

abydos_buffer_t *abydos_buffer_clear(abydos_buffer_t *);
#define abydos_buffer_size(b) ((b)->buffer_len + (b)->data_len)
void abydos_buffer_add(abydos_buffer_t *,const uint8_t *, size_t);
void abydos_buffer_add_back(abydos_buffer_t *,const uint8_t *,size_t);
int abydos_buffer_pop(abydos_buffer_t *);
void abydos_buffer_privatize(abydos_buffer_t *);
const uint8_t *abydos_buffer_copy(abydos_buffer_t *,uint8_t *,size_t);
const uint8_t *abydos_buffer_get(abydos_buffer_t *,size_t);
const uint8_t *abydos_buffer_peek(abydos_buffer_t *,size_t *);
int abydos_buffer_peek_at(abydos_buffer_t *,int);
void abydos_buffer_skip(abydos_buffer_t *,size_t);

#endif /* abydos_buffer_h */
