/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef dcs_h
#define dcs_h

#include <stddef.h>

typedef struct _dcs_decoder_t dcs_decoder_t;

typedef struct{
    //void(*text)(void *userdata, const char *str, size_t len);
    void(*begin)(void *userdata, int command);
    void(*end)(void *userdata, int command);
    void(*param)(void *userdata, const char *param);
    void(*data)(void *userdata, int data);
    void(*write)(void *userdata, int ch);
}dcs_interface_t;

dcs_decoder_t *dcs_decoder_new(const dcs_interface_t*,void *userdata);
void dcs_decoder_free(dcs_decoder_t *dec);
int dcs_decoder_write(dcs_decoder_t *dec, int ch);
int dcs_decoder_writes(dcs_decoder_t *dec, const char *str, size_t len);

#endif /* dcs_h */
