/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef revenge_cairo_h
#define revenge_cairo_h

extern "C"{
#include <cairo.h>
}
#include <librevenge/librevenge.h>

using namespace librevenge;

class RVNGCairoDrawingGenerator: public RVNGDrawingInterface{
private:
    cairo_surface_t *surface;
    int *width;
    int *height;
public:
    RVNGCairoDrawingGenerator(cairo_surface_t *surface, int *width=NULL, int *height=NULL)
    :surface(surface)
    ,width(width)
    ,height(height)
    {}

    virtual void startDocument(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void endDocument(){DEBUG_p("begin");}
    virtual void setDocumentMetaData(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void defineEmbeddedFont(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void startPage(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void endPage(){DEBUG_p("begin");}
    virtual void startMasterPage(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void endMasterPage(){DEBUG_p("begin");}
    virtual void setStyle(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void startLayer(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void endLayer(){DEBUG_p("begin");}
    virtual void startEmbeddedGraphics(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void endEmbeddedGraphics(){DEBUG_p("begin");}
    virtual void openGroup(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void closeGroup(){DEBUG_p("begin");}

    // Different primitive shapes
    virtual void drawRectangle(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void drawEllipse(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void drawPolygon(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void drawPolyline(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void drawPath(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void drawGraphicObject(const RVNGPropertyList &propList);
    virtual void drawConnector(const RVNGPropertyList &propList){DEBUG_p("begin");}

    // Embedded text object
    virtual void startTextObject(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void endTextObject(){DEBUG_p("begin");}
    virtual void startTableObject(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void openTableRow(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void closeTableRow(){DEBUG_p("begin");}
    virtual void openTableCell(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void closeTableCell(){DEBUG_p("begin");}
    virtual void insertCoveredTableCell(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void endTableObject(){DEBUG_p("begin");}
    virtual void insertTab(){DEBUG_p("begin");}
    virtual void insertSpace(){DEBUG_p("begin");}
    virtual void insertText(const RVNGString &text){DEBUG_p("begin");}
    virtual void insertLineBreak(){DEBUG_p("begin");}
    virtual void insertField(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void openOrderedListLevel(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void openUnorderedListLevel(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void closeOrderedListLevel(){DEBUG_p("begin");}
    virtual void closeUnorderedListLevel(){DEBUG_p("begin");}
    virtual void openListElement(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void closeListElement(){DEBUG_p("begin");}
    virtual void defineParagraphStyle(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void openParagraph(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void closeParagraph(){DEBUG_p("begin");}
    virtual void defineCharacterStyle(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void openSpan(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void closeSpan(){DEBUG_p("begin");}
    virtual void openLink(const RVNGPropertyList &propList){DEBUG_p("begin");}
    virtual void closeLink(){DEBUG_p("begin");}
};

#endif /* revenge_cairo_h */
