/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef svgcolor_h
#define svgcolor_h

#include <stdint.h>
#include <sys/types.h>                  /* ssize_t */

#include "xmlutil.h"

typedef struct _svg_color_context_t YYSTYPE;
typedef void *yyscan_t;

typedef struct{
    yyscan_t scanner;
}svg_color_parser_t;

int svgcolorlex_init(yyscan_t*);
#define svg_color_parser_init(a) svgcolorlex_init(&(a)->scanner)
int svgcolorlex_destroy(yyscan_t);
#define svg_color_parser_done(a) svgcolorlex_destroy((a)->scanner);


typedef struct{
    const char *name;
    uint32_t rgb;
}svg_color_t;

typedef struct _svg_color_context_t svg_color_context_t;

typedef struct{
    void(*color)(svg_color_context_t*, uint32_t);
    void(*hex3)(svg_color_context_t*, const char *s);
    void(*hex6)(svg_color_context_t*, const char *s);
    void(*channel)(svg_color_context_t*, double);
}svg_color_interface_t;

struct _svg_color_context_t{
    const svg_color_interface_t *vt;
    color_t *color;
    int channel;
};

//const svg_color_t *svg_color_lookup(const char*);
int svg_color_parse(svg_color_parser_t*, color_t*, const char*, ssize_t);

#endif /* svgcolor_h */
