/*
 * Copyright (C) 2021  Magnus Bergman <magnus@snisurset.net>
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, see <http:/www.gnu.org/licenses/>
 */
%option reentrant
%option bison-bridge
%option nounput noinput

%{

#include "svgcolor.h"

#define SET_COLOR(a) yylval->vt->color(yylval, a)

%}

HEX [0-9A-Fa-f]
DIGIT [0-9]
INT {DIGIT}+
REAL {INT}"."{DIGIT}+
PERCENT {INT}("."{DIGIT}+)?%

%%

black SET_COLOR(0x000000);
navy SET_COLOR(0x000080);
darkblue SET_COLOR(0x00008B);
mediumblue SET_COLOR(0x0000CD);
blue SET_COLOR(0x0000FF);
darkgreen SET_COLOR(0x006400);
green SET_COLOR(0x008000);
teal SET_COLOR(0x008080);
darkcyan SET_COLOR(0x008B8B);
deepskyblue SET_COLOR(0x00BFFF);
darkturquoise SET_COLOR(0x00CED1);
mediumspringgreen SET_COLOR(0x00FA9A);
lime SET_COLOR(0x00FF00);
springgreen SET_COLOR(0x00FF7F);
cyan SET_COLOR(0x00FFFF);
aqua SET_COLOR(0x00FFFF);
midnightblue SET_COLOR(0x191970);
dodgerblue SET_COLOR(0x1E90FF);
lightseagreen SET_COLOR(0x20B2AA);
forestgreen SET_COLOR(0x228B22);
seagreen SET_COLOR(0x2E8B57);
darkslategray SET_COLOR(0x2F4F4F);
darkslategrey SET_COLOR(0x2F4F4F);
limegreen SET_COLOR(0x32CD32);
mediumseagreen SET_COLOR(0x3CB371);
turquoise SET_COLOR(0x40E0D0);
royalblue SET_COLOR(0x4169E1);
steelblue SET_COLOR(0x4682B4);
darkslateblue SET_COLOR(0x483D8B);
mediumturquoise SET_COLOR(0x48D1CC);
indigo SET_COLOR(0x4B0082);
darkolivegreen SET_COLOR(0x556B2F);
cadetblue SET_COLOR(0x5F9EA0);
cornflowerblue SET_COLOR(0x6495ED);
mediumaquamarine SET_COLOR(0x66CDAA);
dimgrey SET_COLOR(0x696969);
dimgray SET_COLOR(0x696969);
slateblue SET_COLOR(0x6A5ACD);
olivedrab SET_COLOR(0x6B8E23);
slategrey SET_COLOR(0x708090);
slategray SET_COLOR(0x708090);
lightslategray SET_COLOR(0x778899);
lightslategrey SET_COLOR(0x778899);
mediumslateblue SET_COLOR(0x7B68EE);
lawngreen SET_COLOR(0x7CFC00);
chartreuse SET_COLOR(0x7FFF00);
aquamarine SET_COLOR(0x7FFFD4);
maroon SET_COLOR(0x800000);
purple SET_COLOR(0x800080);
olive SET_COLOR(0x808000);
gray SET_COLOR(0x808080);
grey SET_COLOR(0x808080);
skyblue SET_COLOR(0x87CEEB);
lightskyblue SET_COLOR(0x87CEFA);
blueviolet SET_COLOR(0x8A2BE2);
darkred SET_COLOR(0x8B0000);
darkmagenta SET_COLOR(0x8B008B);
saddlebrown SET_COLOR(0x8B4513);
darkseagreen SET_COLOR(0x8FBC8F);
lightgreen SET_COLOR(0x90EE90);
mediumpurple SET_COLOR(0x9370DB);
darkviolet SET_COLOR(0x9400D3);
palegreen SET_COLOR(0x98FB98);
darkorchid SET_COLOR(0x9932CC);
yellowgreen SET_COLOR(0x9ACD32);
sienna SET_COLOR(0xA0522D);
brown SET_COLOR(0xA52A2A);
darkgray SET_COLOR(0xA9A9A9);
darkgrey SET_COLOR(0xA9A9A9);
lightblue SET_COLOR(0xADD8E6);
greenyellow SET_COLOR(0xADFF2F);
paleturquoise SET_COLOR(0xAFEEEE);
lightsteelblue SET_COLOR(0xB0C4DE);
powderblue SET_COLOR(0xB0E0E6);
firebrick SET_COLOR(0xB22222);
darkgoldenrod SET_COLOR(0xB8860B);
mediumorchid SET_COLOR(0xBA55D3);
rosybrown SET_COLOR(0xBC8F8F);
darkkhaki SET_COLOR(0xBDB76B);
silver SET_COLOR(0xC0C0C0);
mediumvioletred SET_COLOR(0xC71585);
indianred SET_COLOR(0xCD5C5C);
peru SET_COLOR(0xCD853F);
chocolate SET_COLOR(0xD2691E);
tan SET_COLOR(0xD2B48C);
lightgray SET_COLOR(0xD3D3D3);
lightgrey SET_COLOR(0xD3D3D3);
thistle SET_COLOR(0xD8BFD8);
orchid SET_COLOR(0xDA70D6);
goldenrod SET_COLOR(0xDAA520);
palevioletred SET_COLOR(0xDB7093);
crimson SET_COLOR(0xDC143C);
gainsboro SET_COLOR(0xDCDCDC);
plum SET_COLOR(0xDDA0DD);
burlywood SET_COLOR(0xDEB887);
lightcyan SET_COLOR(0xE0FFFF);
lavender SET_COLOR(0xE6E6FA);
darksalmon SET_COLOR(0xE9967A);
violet SET_COLOR(0xEE82EE);
palegoldenrod SET_COLOR(0xEEE8AA);
lightcoral SET_COLOR(0xF08080);
khaki SET_COLOR(0xF0E68C);
aliceblue SET_COLOR(0xF0F8FF);
honeydew SET_COLOR(0xF0FFF0);
azure SET_COLOR(0xF0FFFF);
sandybrown SET_COLOR(0xF4A460);
wheat SET_COLOR(0xF5DEB3);
beige SET_COLOR(0xF5F5DC);
whitesmoke SET_COLOR(0xF5F5F5);
mintcream SET_COLOR(0xF5FFFA);
ghostwhite SET_COLOR(0xF8F8FF);
salmon SET_COLOR(0xFA8072);
antiquewhite SET_COLOR(0xFAEBD7);
linen SET_COLOR(0xFAF0E6);
lightgoldenrodyellow SET_COLOR(0xFAFAD2);
oldlace SET_COLOR(0xFDF5E6);
red SET_COLOR(0xFF0000);
fuchsia SET_COLOR(0xFF00FF);
magenta SET_COLOR(0xFF00FF);
deeppink SET_COLOR(0xFF1493);
orangered SET_COLOR(0xFF4500);
tomato SET_COLOR(0xFF6347);
hotpink SET_COLOR(0xFF69B4);
coral SET_COLOR(0xFF7F50);
darkorange SET_COLOR(0xFF8C00);
lightsalmon SET_COLOR(0xFFA07A);
orange SET_COLOR(0xFFA500);
lightpink SET_COLOR(0xFFB6C1);
pink SET_COLOR(0xFFC0CB);
gold SET_COLOR(0xFFD700);
peachpuff SET_COLOR(0xFFDAB9);
navajowhite SET_COLOR(0xFFDEAD);
moccasin SET_COLOR(0xFFE4B5);
bisque SET_COLOR(0xFFE4C4);
mistyrose SET_COLOR(0xFFE4E1);
blanchedalmond SET_COLOR(0xFFEBCD);
papayawhip SET_COLOR(0xFFEFD5);
lavenderblush SET_COLOR(0xFFF0F5);
seashell SET_COLOR(0xFFF5EE);
cornsilk SET_COLOR(0xFFF8DC);
lemonchiffon SET_COLOR(0xFFFACD);
floralwhite SET_COLOR(0xFFFAF0);
snow SET_COLOR(0xFFFAFA);
yellow SET_COLOR(0xFFFF00);
lightyellow SET_COLOR(0xFFFFE0);
ivory SET_COLOR(0xFFFFF0);
white SET_COLOR(0xFFFFFF);

{PERCENT} yylval->vt->channel(yylval, atof(yytext)/100);
{REAL} yylval->vt->channel(yylval, atof(yytext));
{INT} yylval->vt->channel(yylval, (double)atoi(yytext)/255);

#{HEX}{6} yylval->vt->hex6(yylval, yytext);
#{HEX}{3} yylval->vt->hex3(yylval, yytext);

rgb"(" printf("begin\n");
")" printf("end\n");

[ ,]+ printf("sep\n");

. { printf("unknown: %s\n", yytext); return -1; }

%%
