/*
 * Copyright (C) 2017  Teemu Suutari
 * Copyright (C) 2020  Magnus Bergman <magnus@snisurset.net>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 */
#ifndef crc_h
#define crc_h

#include <cstdint>

#include "buffer.h"

// The most common CRC16

uint16_t CRC16(const Buffer &buffer,size_t offset,size_t len,uint16_t accumulator);

uint16_t CRC16Byte(uint8_t ch,uint16_t accumulator) noexcept;

// The most common CRC32

uint32_t CRC32(const Buffer &buffer,size_t offset,size_t len,uint32_t accumulator);

uint32_t CRC32Byte(uint8_t ch,uint32_t accumulator) noexcept;

// Same polynomial, but in reverse...

uint32_t CRC32Rev(const Buffer &buffer,size_t offset,size_t len,uint32_t accumulator);

uint32_t CRC32RevByte(uint8_t ch,uint32_t accumulator) noexcept;

#endif /* crc_h */
