/*
 * Copyright (C) 2017  Teemu Suutari
 * Copyright (C) 2020  Magnus Bergman <magnus@snisurset.net>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 */
#include "dec_dlta.h"


void DLTADecode::decode(Buffer &bufferDest,const Buffer &bufferSrc,size_t offset,size_t size)
{
    if (bufferSrc.size()<offset+size)
        throw Buffer::OutOfBoundsError();
    if (bufferDest.size()<offset+size)
        throw Buffer::OutOfBoundsError();;
    const uint8_t *src=bufferSrc.data()+offset;
    uint8_t *dest=bufferDest.data()+offset;

    uint8_t ctr=0;
    for (size_t i=0;i<size;i++){
        ctr+=src[i];
        dest[i]=ctr;
    }
}


void DLTADecode::decompressImpl(Buffer &rawData,const Buffer&,bool verify)
{
	if (rawData.size()<_packedData.size()) throw Decompressor::DecompressionError();
	decode(rawData,_packedData,0,_packedData.size());
}
